apeman-api-fs
==========

<!---
This file is generated by ape-tmpl. Do not update manually.
--->

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]
[![JS Standard][bd_standard_shield_url]][bd_standard_url]

[bd_repo_url]: https://github.com/apeman-api-labo/apeman-api-fs
[bd_travis_url]: http://travis-ci.org/apeman-api-labo/apeman-api-fs
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-api-labo/apeman-api-fs.svg?style=flat
[bd_travis_com_url]: http://travis-ci.com/apeman-api-labo/apeman-api-fs
[bd_travis_com_shield_url]: https://api.travis-ci.com/apeman-api-labo/apeman-api-fs.svg?token=
[bd_license_url]: https://github.com/apeman-api-labo/apeman-api-fs/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-api-labo/apeman-api-fs
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-api-labo/apeman-api-fs.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-api-labo/apeman-api-fs.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-api-labo/apeman-api-fs
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-api-labo/apeman-api-fs.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-api-fs
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-api-fs.svg?style=flat
[bd_standard_url]: http://standardjs.com/
[bd_standard_shield_url]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

File system API for apeman

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>



<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/guides/01.Installation.md.hbs" Start -->

<a name="section-doc-guides-01-installation-md"></a>

Installation
-----

```bash
$ npm install apeman-api-fs --save
```


<!-- Section from "doc/guides/01.Installation.md.hbs" End -->

<!-- Section from "doc/guides/02.Usage.md.hbs" Start -->

<a name="section-doc-guides-02-usage-md"></a>

Usage
---------

Define a module in Apemanfile and run the server.

```javascript
/** Example of Apemanfile.js */

'use strict'

const co = require('co')

let { NODE_ENV } = process.env

module.exports = {
  $cwd: __dirname,
  $pkg: { /* ... */ },
  $proto: [ /* ... */ ],
  $api: {
    // Define APIs
    'fs': require('apeman-api-fs')({
      root: __dirname,
      logging: NODE_ENV === 'development'
    })
  }
}

```

Then, call the module from client script

```javascript
#!/usr/bin/env node

/**
 * Example client
 */
'use strict'

const co = require('co')
const apemanApiClient = require('apeman-api-client')

co(function * () {
  // Setup an client
  let api = yield apemanApiClient('/api')

  // Connect to a module
  let fs = yield api.connect('fs')
  let pong = yield fs.ping()
  /* ... */

  yield fs.mkdirAll([
    'bin',
    'lib',
    'lib/config',
    'test'
  ])

  yield fs.chmod('bin/*.js', '755')

  yield fs.chmodAll({ 'ci/*.js': '755' })
  /* ... */
})


```


<!-- Section from "doc/guides/02.Usage.md.hbs" End -->

<!-- Section from "doc/guides/03.Methods.md.hbs" Start -->

<a name="section-doc-guides-03-methods-md"></a>

Methods
---------

The following methods are provided by the API.

+ [.ping(pong)](#method-ping)
+ [.glob(pattern, options)](#method-glob)
+ [.exists(filename)](#method-exists)
+ [.stat(filename)](#method-stat)
+ [.mkdir(dirname)](#method-mkdir)
+ [.mkdirAll(dirnames)](#method-mkdir-all)
+ [.chmod(pattern, permission)](#method-chmod)
+ [.chmodAll(permissions)](#method-chmod-all)
+ [.copy(src, dest)](#method-copy)

<a name="method-ping"></a>
### .ping(pong)

Test the reachability of the api

| Param | Type | Description |
| ----- | ---- | ----------- |
| pong  | <code>string</code> | Pong message to return |

<a name="method-glob"></a>
### .glob(pattern, options)

Resolve glob file name pattern

| Param | Type | Description |
| ----- | ---- | ----------- |
| pattern  | <code>string</code> | Glob file name pattern |
| options  | <code>object</code> | Optional settings |

<a name="method-exists"></a>
### .exists(filename)

File exists or not

| Param | Type | Description |
| ----- | ---- | ----------- |
| filename  | <code>string</code> | File name |

<a name="method-stat"></a>
### .stat(filename)

Get stat of a file

| Param | Type | Description |
| ----- | ---- | ----------- |
| filename  | <code>string</code> | File name to get stat |

<a name="method-mkdir"></a>
### .mkdir(dirname)

Generate a directory

| Param | Type | Description |
| ----- | ---- | ----------- |
| dirname  | <code>string</code> | Directory name to generate |

<a name="method-mkdir-all"></a>
### .mkdirAll(dirnames)

Generate multiple directories

| Param | Type | Description |
| ----- | ---- | ----------- |
| dirnames  | <code>array</code> | Directory names to generate |

<a name="method-chmod"></a>
### .chmod(pattern, permission)

Change file permissions

| Param | Type | Description |
| ----- | ---- | ----------- |
| pattern  | <code>string</code> | Glob filename pattern |
| permission  | <code>string</code> | Permission string (like "644") |

<a name="method-chmod-all"></a>
### .chmodAll(permissions)

Change file permissions

| Param | Type | Description |
| ----- | ---- | ----------- |
| permissions  | <code>array</code> | Pattern and permissions |

<a name="method-copy"></a>
### .copy(src, dest)

Copy file

| Param | Type | Description |
| ----- | ---- | ----------- |
| src  | <code>string</code> | Source file to copy |
| dest  | <code>string</code> | Destination file to copy |



<!-- Section from "doc/guides/03.Methods.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-api-labo/apeman-api-fs/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman][apeman_url]

[apeman_url]: https://github.com/apeman-labo/apeman

<!-- Links End -->
