#!/usr/bin/env node

/**
 * Example client
 */
'use strict'

const co = require('co')
const apemanApiClient = require('apeman-api-client')

co(function * () {
  // Setup an client
  let api = yield apemanApiClient('/api')

  // Connect to a module
  let fs = yield api.connect('fs')
  let pong = yield fs.ping()
  /* ... */

  yield fs.mkdirAll([
    'bin',
    'lib',
    'lib/config',
    'test'
  ])

  yield fs.chmod('bin/*.js', '755')

  yield fs.chmodAll({ 'ci/*.js': '755' })
  /* ... */
})

